<template>
  <div id="app">
    <h1>Up To Date Stock Data</h1>
    <h3 class="Symbol">{{ symbol }}</h3>
    <symbol-input v-bind:handleSubmit="handleSubmit"></symbol-input>
    <stock-table v-bind:rateLimitExceeded="rateLimitExceeded" v-bind:entries="entries" v-bind:loading="loading" v-bind:error="error"></stock-table>
    <p class="DataAttribution">Stock data provided by <a href="https://www.alphavantage.co">AlphaVantage</a></p>
  </div>
</template>

<script>
import StockTable from "./components/StockTable.vue";
import SymbolInput from "./components/SymbolInput.vue";
import fetchEntries from "@/utils/fetchEntries.js";
import { removeChart } from "@/utils/chartUtils.js";

export default {
  name: "app",
  data: function() {
    return {
      loading: true,
      error: null,
      entries: [],
      rateLimitExceeded: false,
      symbol: "msft",
      interval: "5min"
    };
  },
  created: function() {
    this.loading = true;
    this.entries = [];

    this.fetchEntries(this.symbol, this.interval);
    setInterval(this.fetchEntries(this.symbol, this.interval), 30000);
  },
  methods: {
    fetchEntries,
    handleSubmit: function(symbol, interval) {
      removeChart();
      this.loading = true;
      this.error = null;
      this.entries = [];
      this.symbol = symbol;
      this.interval = interval;

      this.fetchEntries(symbol, interval);
    }
  },
  components: {
    StockTable,
    SymbolInput
  }
};
</script>

<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
.Symbol {
  text-transform: uppercase;
}
</style>
